/*
Copyright 2023.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/dapr/kubernetes-operator/api/operator/v1alpha1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// DaprInstanceLister helps list DaprInstances.
// All objects returned here must be treated as read-only.
type DaprInstanceLister interface {
	// List lists all DaprInstances in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.DaprInstance, err error)
	// DaprInstances returns an object that can list and get DaprInstances.
	DaprInstances(namespace string) DaprInstanceNamespaceLister
	DaprInstanceListerExpansion
}

// daprInstanceLister implements the DaprInstanceLister interface.
type daprInstanceLister struct {
	listers.ResourceIndexer[*v1alpha1.DaprInstance]
}

// NewDaprInstanceLister returns a new DaprInstanceLister.
func NewDaprInstanceLister(indexer cache.Indexer) DaprInstanceLister {
	return &daprInstanceLister{listers.New[*v1alpha1.DaprInstance](indexer, v1alpha1.Resource("daprinstance"))}
}

// DaprInstances returns an object that can list and get DaprInstances.
func (s *daprInstanceLister) DaprInstances(namespace string) DaprInstanceNamespaceLister {
	return daprInstanceNamespaceLister{listers.NewNamespaced[*v1alpha1.DaprInstance](s.ResourceIndexer, namespace)}
}

// DaprInstanceNamespaceLister helps list and get DaprInstances.
// All objects returned here must be treated as read-only.
type DaprInstanceNamespaceLister interface {
	// List lists all DaprInstances in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.DaprInstance, err error)
	// Get retrieves the DaprInstance from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.DaprInstance, error)
	DaprInstanceNamespaceListerExpansion
}

// daprInstanceNamespaceLister implements the DaprInstanceNamespaceLister
// interface.
type daprInstanceNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha1.DaprInstance]
}
